{% extends 'base.html' %}


{% block style %}
<link href="{{ url_for('static', filename='css/index.css') }}" rel="stylesheet">
<link href="{{ url_for('static', filename='css/popup.css') }}" rel="stylesheet">
<link href="{{ url_for('static', filename='css/distribution.css') }}" rel="stylesheet">
<link href="{{ url_for('static', filename='css/overlays.css') }}" rel="stylesheet">
<link href="{{ url_for('static', filename='css/menus.css') }}" rel="stylesheet">

<link href="{{ url_for('static', filename='css/build.css') }}" rel="stylesheet">
{% endblock %}



{% block content %}

<nav>
    {% for record_type in record_types %}
        <form class="nav-link
                    {% if loop.first %}nav-link-start
                    {% elif loop.last %}nav-link-end
                    {% else %}nav-link-mid{% endif %}"
                method="POST">
            <button type="submit" name="record_type" value="{{ record_type.name }}"
                    class="btn-unstyled nav-link-content nav-link-text nav-link-icon
                        {% if user_records.record_type.name == record_type.name %}nav-link-active{% endif %}"
                        style="position: relative;">
                <!-- RecordType Tooltip (for small screens only) -->
                <div class="nav-link-content-tooltip small-screen" title="{{ record_type.name }}"></div>

                <!-- RecordType Text (for large screen only) -->
                <div class="big-screen">{{ record_type.name }}</div>

                <!-- RecordType Icon (for small screens only) -->
                <div class="nav-icon small-screen">
                    {% if user_records.record_type.name == record_type.name %}
                        <img src="{{ url_for('static', filename=navicons.get('active').get(record_type.name)) }}" />
                    {% else %}
                        <img src="{{ url_for('static', filename=navicons.get('base').get(record_type.name)) }}" />
                    {% endif %}
                </div>
            </button>
        </form>
    {% endfor %}
</nav>

<!-- -------------------- SEARCH BAR -------------------- -->
<!-- -------------------- /SEARCH BAR -------------------- -->


<!-- include 'card.html' -->


<div class="records-container">
    <div id="record_id" class="record-card">{% include 'records_id.html' %}</div>
    <div id="string_filters" class="record-card">{% include 'records_string.html' %}</div>
    <div id="form_filters" class="record-card">{% include 'records_form.html' %}</div>
    <div id="level_filters" class="record-card">{% include 'records_level.html' %}</div>
    <div id="traits" class="record-card">{% include 'records_traits.html' %}</div>
    <div id="variable_NULL_ItemCount_PackageIdx" class="record-card">{% include 'records_variable.html' %}</div>
    <div id="chance" class="record-card">{% include 'records_chance.html' %}</div>
    <div id="save_record" class="record-card">{% include 'records_submit.html' %}</div>       <!-- records_submit -->
</div>


<!-- -------------------- SAVED RECORDS -------------------- -->
<div class="records-container">
    <div class="dtable-panel">{% include 'records_distribution.html' %}</div>
</div>
<!-- -------------------- /SAVED RECORDS -------------------- -->


<!-- -------------------- MENUS, POPUPS & OVERLAYS -------------------- -->
{% include 'popup.html' %}
{% include 'menu_settings.html' %}
{% include 'menu_explorer.html' %}

{% if input.tag == AppInputTag['IsTutorialActive'] %}
    {% include 'overlay_tutorial.html' %}
{% elif input.tag == AppInputTag['IsImportActive'] %}
    {% include 'overlay_imports.html' %}
{% elif input.tag == AppInputTag['IsExportActive'] %}
    {% include 'overlay_export.html' %}
{% elif input.tag == AppInputTag['IsRenamingCategoryActive'] %}
    {% include 'overlay_rename_category.html' %}
{% elif input.tag == AppInputTag['IsChangingCategoryActive'] %}
    {% include 'overlay_change_category.html' %}
{% elif input.tag == AppInputTag['IsSettingCustomPathActive'] %}
    {% include 'overlay_custom_dirpath.html' %}
<!-- {% elif input.tag == AppInputTag['IsLoading'] %}
    {% include 'overlay_loading.html' %} -->
{% endif %}

{% include 'overlay_loading.html' %}
<!-- -------------------- /POPUP & OVERLAYS -------------------- -->


<!-- -------------------- TESTS & ATTENTION NEEDED SECTION -------------------- -->
<!-- Problems to solve: StringFilters ""="NONE" ; FormFilters = ToDo ; SkillLevel NONE=99 ; reset  item_count et package_index et variable_field quand record_type switché ? -->
<!-- Gérer apparition popup selon présence (if dans le template correspondant +/- template spécifique comme les cards ?) d'un contenu dans la variable correspondante (de valeur à reset à chaque POST - au début avant les "if/elif" dans views) -->
<!-- Régler les soucis d'affichage mobile ? -->
<!-- Ajouter un logotype favicon ? -->
<!-- -------------------- /TESTS & ATTENTION NEEDED SECTION -------------------- -->


<script>
    /*
    // Check window width
    function logWindowWidth() {
        const windowWidth = window.innerWidth;
        console.log("Largeur de la fenêtre : " + windowWidth + "px");
    }
    // Écoute l'événement de redimensionnement de la fenêtre
    window.addEventListener("resize", logWindowWidth);

    // Appelle la fonction une première fois au chargement initial de la page
    logWindowWidth();
    */

    // // document.getElementById("myButton").addEventListener("click", function(){
    // //   fetch('/execute_code')
    // //     .then(response => response.json())
    // //     .then(data => console.log(data));
    // // });
    // function executeCode() {
    //     fetch('/execute_code')
    //     .then(fetch('/index'))
    //     // .then(location.reload());
    // }
    // // function executeCode() {
    // //     fetch('/execute_code')
    // //     .then(response => response.json())
    // //     .then(data => {
    // //         // Mettre à jour le contenu de la page avec le résultat de la requête
    // //         document.getElementById('result').innerText = data.result;
    // //     });
    // // }


    // Functions to show/hide loading overlay
    function showLoadingOverlay() {
        document.querySelector('.overlay-loading').style.display = 'flex';
        // TODO Le récupérer dans une const, puis faire un check pour vérifier qu'elle n'est pas null avant de changer le style ?
        //      (pour éviter erreur reçue avec overlay_custom_dirpath : "Uncaught TypeError: Cannot read properties of null (reading 'style') at hideLoadingOverlay")?
    }
    function hideLoadingOverlay() {
        document.querySelector('.overlay-loading').style.display = 'none';
        // TODO Le récupérer dans une const, puis faire un check pour vérifier qu'elle n'est pas null avant de changer le style ?
        //      (pour éviter erreur reçue avec overlay_custom_dirpath : "Uncaught TypeError: Cannot read properties of null (reading 'style') at hideLoadingOverlay")?
    }

    // /**
    //  * Function to set listeners and handle loading overlay display
    //  * @param {string} id: 'import', 'export'
    //  * @param {string} event: 'click'
    //  */
    // function setListener(id, event) {
    //     // Listen to given event on given DOM element
    //     document.getElementById(id).addEventListener(event, function() {
    //         // Show loading overlay
    //         showLoadingOverlay();

    //         // Make an AJAX request to the target route (or server)
    //         var xhr = new XMLHttpRequest();
    //         xhr.open('GET', `/${id}/`, true);

    //         // Hide loading overlay when done
    //         xhr.onload = function() {
    //             hideLoadingOverlay();
    //         };
            
    //         xhr.send();
    //     });
    // }

    /**
     * Function to set listeners and handle loading overlay display
     */
    function handleLoadingOverlay() {
        // Listen to the window's page unloading start event
        window.addEventListener("beforeunload", function() {
            // Show loading overlay
            showLoadingOverlay();
        });

        // Listen to the window's page loading start event
        // window.addEventListener("DOMContentLoaded", function() {
        //     showLoadingOverlay();
        // });
        
        // Listen to the window's page loading end event
        window.addEventListener("load", function() {
            // Hide loading overlay when done
            hideLoadingOverlay();
        });
    }

    // Create needed listeners
    handleLoadingOverlay();
    // setListener('import', 'click');
    // setListener('export', 'click');
    // // TODO Do the same for other time-consuming operations (and/or for 'index'?)

</script>

{% endblock %}